      subroutine emmstda(y,n,p,ng,ncov,
     &pro,mu,sigma,dof,delta,tau,ev,elogv,ez1v,ez2v,
     &loglik,lk,clust,itmax,epsilon,error)
      implicit none
c---------------------------------------------------------------------
c   global variables
      integer n,p,ng,error,ncov,itmax
      integer clust(*),method(ng)
      double precision y(n,*), mu(p,*), sigma(p,p,*), dof(*)
      double precision delta(p,*), pro(*), loglik, lk(*)
      double precision tau(n,*),ev(n,*),elogv(n,*)
      double precision ez1v(n,*),  ez2v(n,*)
      double precision sumtau(ng)!,corr(p,p,ng)
      double precision sumlogv(ng), sumvt(ng)
      double precision sumzt(ng),epsilon
      integer h,i,it,k
      double precision zero, one, two,bx
      parameter        (zero = 0.d0, one = 1.d0, two = 2.d0)
       bx=50.0d0
      do h=1,ng
        sumtau(h)=zero
        do i=1,n
         tau(i,h)=zero
         if(clust(i) .eq. h) tau(i,h)=one
         sumtau(h)=sumtau(h)+tau(i,h)
        enddo
        pro(h)=sumtau(h)/dble(n)
        dof(h)=dble(4)
        method(h)=1
      enddo
      call mstepmvn(y,n,p,ng,ncov,tau,sumtau,
     &mu,sigma)
      call skew(y,n,p,ng,tau,sumtau,mu,sigma,delta)
      error=0
      do 1000 it=1,itmax
          lk(it)=zero
      call estepmstda(y,n,p,ng,pro,mu,sigma,dof,delta,
     &tau,ev,elogv,ez1v,ez2v,sumtau,sumvt,sumzt,sumlogv,
     &loglik,clust,error,method)
         if(error.ne.0) then
         error=3
         return
         endif
      lk(it)=loglik
      call mstepmst(y,n,p,ng,ncov,
     &tau,ev,ez1v,ez2v,sumtau,sumvt,sumzt,
     &mu,sigma,delta)
      call getdof(n, ng, sumtau, sumlogv, dof, bx)
         if(it.ge.itmax) error=1
         if(it .le. 10) goto 1000
         if( ((abs(lk(it-10)-lk(it))) .lt. (abs(lk(it-10))* epsilon))
     &   .and. ((abs(lk(it-1)-lk(it))) .lt. (abs(lk(it-1))* epsilon)) )
     &   goto 5000
1000  continue
5000  continue
      return
      end
      subroutine estepmstda(x,n,p,g,pro,mu,sigma,dof,delta,
     &tau,ev,elogv,ez1v,ez2v,sumtau,sumvt,sumzt,sumlogv,
     &loglik,clust,error,method)
      implicit NONE
      integer            n, p, G, error, method(g),clust(*)
      double precision   loglik
      double precision   x(n,*), tau(n,  *  ),dof(*),delta(p,*)
      double precision   mu(p,*), Sigma(p,p,*), pro(  *  )
      double precision   ev(n,*), elogv(n,*), sumtau(*),sumlogv(*)
      double precision   ez1v(n,*), ez2v(n,*),sumvt(*),sumzt(*)
      integer                  i, k
      double precision        zero, one, two
      parameter              (zero = 0.d0, one = 1.d0, two = 2.d0)
      error  = 0
      call denmst2(x,n,p,g,pro,mu,sigma,dof,delta,
     &tau,ev,elogv,ez1v,ez2v,error,method)
      if(error .ne. 0) then
            error=22
            return
      endif
      loglik = zero
      call gettau(tau,pro,loglik,n,g,error)
      if(error .ne. 0) then
            error=23
            return
      endif
      do k=1,G
         sumtau(k)  = zero
         sumzt(k)   = zero
         sumvt(k)   = zero
         sumlogv(k) = zero
         do i=1,n
          tau(i,k)=zero
          if(clust(i)==k) tau(i,k)=one
          sumtau(k)   =  sumtau(k) + tau(i,k)
          sumzt(k)= sumzt(k)+ez2v(i,k)*tau(i,k)
          sumvt(k)= sumvt(k)+ev(i,k)  *tau(i,k)
          sumlogv(k)=sumlogv(k)+(elogv(i,k))*tau(i,k)
        enddo
      end do
      return
      end
